"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.replace = void 0;
var tslib_1 = require("tslib");
var postcss_1 = tslib_1.__importDefault(require("postcss"));
var memoizerific_1 = tslib_1.__importDefault(require("memoizerific"));
var postcss_px_to_viewport_1 = tslib_1.__importDefault(require("postcss-px-to-viewport"));
var configuration_1 = tslib_1.__importDefault(require("./configuration"));
var FAKE_OPENING_WRAPPER = "styled-fake-wrapper/* start of styled-fake-wrapper */{\n";
var FAKE_CLOSING_WRAPPER = "\n}/* end of styled-fake-wrapper */";
var PAIR_REG = /[\s\w-]+:([\s-.\d]+px)+/;
var SPLIT_SEPARATORS = [';', '\n', '{', '}'];
var errorTokenMap = new Map();
exports.replace = memoizerific_1.default(10)(function (cssText) {
    var _a = configuration_1.default.config, tags = _a.tags, others = tslib_1.__rest(_a, ["tags"]);
    var options = tslib_1.__assign({}, others);
    try {
        var joinCssText = "" + FAKE_OPENING_WRAPPER + cssText + FAKE_CLOSING_WRAPPER;
        var css = postcss_1.default([postcss_px_to_viewport_1.default(options)]).process(joinCssText, {}).css;
        if (errorTokenMap.has(cssText)) {
            errorTokenMap.delete(cssText);
        }
        return css.replace(FAKE_OPENING_WRAPPER, '').replace(FAKE_CLOSING_WRAPPER, '');
    }
    catch (ignored) {
        var tempResults_1 = [];
        var cssStr_1 = cssText;
        SPLIT_SEPARATORS.forEach(function (separator) {
            var tokens = cssStr_1.split(separator);
            for (var _i = 0, tokens_1 = tokens; _i < tokens_1.length; _i++) {
                var token = tokens_1[_i];
                var tokenRemoveComments = token.replace(/\s*(?<!(\/\*.*|[:：]))\/\/.*$/gm, '');
                if (PAIR_REG.test(tokenRemoveComments) &&
                    tokenRemoveComments.includes(others.unitToConvert) &&
                    !errorTokenMap.get(token) &&
                    !!token.trim()) {
                    errorTokenMap.set(token, true);
                    tempResults_1.push(exports.replace(tokenRemoveComments));
                }
                else {
                    tempResults_1.push(token);
                }
            }
            cssStr_1 = tempResults_1.join(separator);
            tempResults_1 = [];
        });
        return cssStr_1;
    }
});
